CON

'' PropCOMM VT100_VGA V2.0b By Jeff Ledger
'' VT100 Terminal

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000

   debugvideo        = 12
   DEBUGYELLOW       = $1E  ''DEBUG VIDEO SENT TO TV --
   DEBUGWHITE        = $AF  ''SHOULD NOT HURT ANYTHING


   termcolor = LIGHTAMBER
   keyboard  = 26                     ' Keyboard input
   video     = 16                     ' Video output

   serXmit   = 9                      ' Serial Transmit
   serRecv   = 8                      ' Serial Receive
   baud      = 9600                   ' Baud Rate

   ''Terminal Colors
   DIMCYAN           = $29
   DIMGREEN          = $27
   DIMORANGE         = $92
   DIMPINK           = $95
   DIMRED            = $C1
   PURPLE            = $99
   CLASSICAMBER      = $A2
   CLASSICAMBERDARK  = $E2
   LIGHTAMBER        = $A5
   WHITE             = $FF
   HOTPINK           = $C9
   PINK              = $D9
   RED               = $C5
   CYAN              = $7F
   DARKBLUE          = $5F
   CLASSICGREEN      = $75

   CR                = $0D
   LF                = $0A
   TAB               = $09
   BKS               = $08

   bspKey            = $C8
   escape            = $CB
   backspace         = $C8
   fReturn           = 13
   fLinefeed         = 10
   fEof              = -1


OBJ
  debug  : "aigeneric_driver"          ' Debug Screen (TV)
  text   : "VGA_1024"                  ' VGA Terminal Driver
  key    : "comboKeyboard"             ' Keyboard Driver
  ser    : "FullDuplexSerial"          ' Full Duplex Serial Controller

PUB start | i, a, b, TimeCnt

  debug.start(debugvideo)                       ' Start debug driver
  debug.str(string("DEBUG READY",13,13))

  key.start(keyboard)                           ' Start keyboard driver
  text.start(video)                             ' Start terminal screen
  ser.start(serRecv,serXmit,0,baud)             ' Control link via prop-plug

  titlescreen
  terminal

PRI terminal | cursor,local,record,remote,vt100,byte2,byte3,byte1,byte4,byte5,byte6,byte7,loop,var1,col,row

  vt100 := 0

  cursor := 0  ' 0=Cursor keys match number keys
  'cursor := 1  ' 1=Cursor keys match Wordstar Movement keys

  repeat
      local := key.key
      if local > 0

         if local > 608         '' Assume CTRL key is being held
            local:=local-608    '' Redefine as CTRL+char

         if local == 203        '' Check for [ESC] Key
            local := 27         '' Change to standard ASCII value

         if local == 208
            local := -1
            titlescreen

         if local == 219 and cursor == 0 ' F12 Switch Cursor mode to WS
            cursor:=1
            local := -1
            text.str(string("Cursor keys in Wordstar Mode",13))

         if local == 219 and cursor == 1 ' F12 Switch Cursor mode to Numbers
            cursor:=0
            local := -1
            text.str(string("Cursor keys in Numbers Mode",13))

         if local == 200 or local == 201 or local == 8
            local := 08
            'text.str(string($C0," ",$C0))


         '' Number Pad compatibility for the cursor keys
         if local == 194 and cursor == 0'' If cursor up
            local := 56  '' Send an 8

         if local == 195 and cursor == 0'' If cursor down
            local := 50  '' Send a 2

         if local == 192 and cursor == 0'' If cursor left
            local := 52  '' Send a 4

         if local == 193 and cursor == 0'' If cursor right
            local := 54  '' Send a 6


         '' Wordstar compatibility for the cursor keys
         if local == 194 and cursor == 1'' If cursor up
            local := 5   '' Send a ^E

         if local == 195 and cursor == 1'' If cursor down
            local := 24  '' Send a ^X

         if local == 192 and cursor == 1'' If cursor left
            local := 19  '' Send a ^S

         if local == 193 and cursor == 1'' If cursor right
            local := 4   '' Send a ^D


         '' 197 END
         '' 196 HOME
         'debug.color(debugyellow)
         'debug.dec(local)
         'debug.color(debugwhite)
         ser.tx(local)
         local := -1

      '## Deal with remote data if present ##


    remote := ser.rxcheck
     if (remote > 0)

      if remote == 15
         remote:=0

      if remote > 0         '' Used for debugging.  Can be removed.
        debug.out(remote)   '' Display everthing on the TV terminal
       'debug.dec(local)


      if remote == 27 'vt100 ESC code is being sent
         vt100:=1
         byte1:=0
         byte2:=0
         byte3:=0
         byte4:=0
         byte5:=0
         byte6:=0
         byte7:=0
         remote:=0 'Don't display the ESC code

      if remote == 91 and vt100 == 1 'look for open bracket [
         vt100:=2 'start recording code

      if remote == 62 and vt100 == 1 or remote == 60 and vt100 == 1'look for < & >
         vt100:=0 ' not sure why this is coming up, can't find in spec.

      if vt100==2 ''Check checking for VT100 emulation codes


         if remote > 10
           byte7:=byte6
           byte6:=byte5 '' My VTCode Mini Buffer
           byte5:=byte4
           byte4:=byte3
           byte3:=byte2 ''Record the last 7 bytes
           byte2:=byte1
           byte1:=remote



         if remote == 109         ' Look for lowercase m
            if byte2 == 91        ' if [m turn off to normal set
               text.inv(0)
            if byte2 == 49        ' is it ESC[1m BOLD
               text.inv(1)
            if byte2 == 55        ' is it ESC[7m REVERSE
               text.inv(1)
            if byte2 == 48        ' 0 is back to normal
               text.inv(0)
            vt100:=0

         '' Remove some unsupported codes from being shown.

         if remote == 104 'look for lowercase h
            vt100:=0

         if remote == 61  'lool for =
            vt100:=0

         if remote == 114 'look for lowercase r
            vt100:=0

         if remote == 108 'look for lowercase l
            vt100:=0

         if remote == 62  'look for >
            vt100:=0

         if remote == 77  'Look for M (SCROLL UP ONE LINE)
            text.scrollM
            vt100:=0

         if remote == 76 'Look for L (SCROLL DOWN ONE LINE)
            text.scrollD
            vt100:=0
            
         if remote == 72 or remote == 102'' HOME CURSOR (uppercase H or lowercase f)
            if byte2==91 or byte2==59   ''look for [H or ;f
               text.home

            '' Check for X & Y with [H or ;f   -   Esc[Line;ColumnH

            else
              if byte4 == 59 '' Assume that col is greater than 9
                byte3:=byte3-48    'Grab 10's
                byte2:=byte2-48    'Grab 1's
                byte3:=byte3*10    'Multiply 10's
                byte3:=byte3+byte2 'Add 1's
                col:=byte3         'Set cols

                if byte7 == 91''Assume row number is greater than 9
                   byte6:=byte6-48 'Grab 10's
                   byte5:=byte5-48 'Grab 1's
                   byte6:=byte6*10 'Multiply 10's
                   byte6:=byte6+byte5 'Add 1's
                   row:=byte6

                if byte6 == 91'Assume row number is less than 10
                   byte5:=byte5-48 'Grab 1's
                   row:=byte5

              if byte3 == 59 '' Assume that col is less an 10
                byte2:=byte2-48    'Grab 1's
                col:=byte2         'set cols

                if byte6 == 91''Assume row number is greater than 9
                   byte5:=byte5-48 'Grab 10's
                   byte4:=byte4-48 'Grab 1's
                   byte5:=byte5*10 'Multiply 10's
                   byte5:=byte5+byte4 'Add 1's
                   row:=byte5
                if byte5 == 91 'Assume that col is greater than 10
                   byte4:=byte4-48 'Grab 1's
                   row:=byte4


              col:=col-1

              if col == -40    ' Patches a bug I havn't found.  *yet*
                 col := 58     ' A Microsoft approach to the problem. :)
              if row == -459
                 row := 1
              if row == -449
                 row := 2      ' Appears to be an issue with reading
              if row == -439   ' single digit rows.
                 row := 3
              if row == -429   ' This patch checks for the bug and replaces
                 row := 4      ' the faulty calculation.
              if row == -419
                 row := 5      ' Add to list to find the source of bug later.
              if row == -409
                 row := 6
              if row == -399
                 row := 7
              if row == -389
                 row := 8
              if row == -379
                 row := 9


              text.cursloc(col,row)

            vt100:=0

         if remote == 74    '' CLEAR SCREEN
            if byte2==91    '' look for [J  '' clear screen from cursor to 25
               text.clsfromcursordown
            vt100:=0
            if byte2==50    '' look for [2J '' clear screen
               text.cls



         if remote == 66    '' CURSOR DOWN    Esc[ValueB
            if byte4 == 91 '' Assume number over 10
              byte3:=byte3-48
              byte2:=byte2-48
              byte3:=byte3*10
              byte3:=byte3+byte2
              var1:=byte3
            if byte3 == 91 '' Assume number is less 10
              byte2:=byte2-48
              var1:=byte2

              'var1:=var1-1 '' Seems to move too far with B2 ''May remove



            loop:=0
            repeat until loop == var1
               loop++
               text.out($C3)

            vt100:=0


         if remote == 65    '' CURSOR UP   Esc[ValueA
            if byte4 == 91 '' Assume number over 10
              byte3:=byte3-48
              byte2:=byte2-48
              byte3:=byte3*10
              byte3:=byte3+byte2
              var1:=byte3
            if byte3 == 91 '' Assume number is less 10
              byte2:=byte2-48
              var1:=byte2

            loop:=0
            repeat until loop == var1
               text.out($C2)
               loop++
            vt100:=0


         if remote == 67    '' CURSOR RIGHT   Esc[ValueC
            if byte4 == 91 '' Assume number over 10
              byte3:=byte3-48
              byte2:=byte2-48
              byte3:=byte3*10
              byte3:=byte3+byte2
              var1:=byte3
            if byte3 == 91 '' Assume number is less 10
              byte2:=byte2-48
              var1:=byte2

            loop:=0
            repeat until loop == var1
               text.out($C1)
               loop++
            vt100:=0



         if remote == 75   '' Clear line  Esc[K
           if byte2 == 91 '' Look for [
             text.clearlinefromcursor


         remote:=0 '' hide all codes from the VGA output.

      if remote == 8
         text.out(backspace)
         remote := 0

      if record == 13 and remote == 13  ''remove LF
         remote :=0

      if remote > 11
           text.out(remote)

      record:=remote ''record last byte


PUB titlescreen

  text.cls
  text.color(termcolor)
  text.str(string(13,"VT100 Terminal by: Jeff Ledger",13))
  text.str(string("Terminal Ready: "))
  text.dec(baud)
  text.str(string(",N,8,1",13))

